//-----------------------------------------------
//Program: Nuevo Menú
//Author: Josebita
//Team: J&J Internacional
//-----------------------------------------------

Program Menu_nuevo;
Const
width=640; height=480; bpp=16;
Local
Int separation=0;
Int done=1;
Int active=0;

Begin
    set_title("Nuevo Menu");    //Initial stuff
    Full_screen = FALSE;
    set_mode (width, height, bpp);
    create_menu(1);
    mouse.graph = load_map("mouse.map");
    write_int(0, width/2, height, 8, OFFSET mouse.x);
    write_int(0, width/2+10, height, 6, OFFSET mouse.y);
End
      
//---------------------------------
// Controls various kinds of menus
//---------------------------------

Process create_menu(Int which);
Private
Int font;
Int max_button;
Int n=0;
Int t_counter=0;    //Time counter
Int delay=30;
Struct ident[10]   //Just to set a reasonable limit
	Int ide;    //Process identifier
End;

Begin
    font = load_fnt("fnt/font.fnt");
    Switch(which)
        Case 1: //Main menu
            max_button = 3;
            ident[n++].ide = button(font, "JUGAR", width/2, height/(max_button+1));
            ident[n++].ide = button(font, "OPCIONES", width/2, height/(max_button+1)*2);
            ident[n].ide = button(font, "SALIR", width/2, height/(max_button+1)*3);
            n=0;
            ident[n].ide.active=1;
        End;
        Case 2: //Options menu
            
        End;
    End;
    Loop
        If((key(_down)) && (done))
            ident[n].ide.active=0;
            If(n++ >= max_button-1)
                n = 0;
            End;
            ident[n].ide.active=1;
            t_counter = timer;
            done = 0;
        End;
        If((key(_up)) && (done))
            ident[n].ide.active=0;
            If(n-- <= 0)
                n = max_button-1;
            End;
            ident[n].ide.active=1;
            t_counter = timer;
            done = 0;
        End;
        If((key(_enter)) && (done))
            perform_action(which*10+n+1);   //The wonders of the positional system
            t_counter = timer;
            done = 0;
        End;
        If(timer > t_counter+delay)
            done = 1;
        End;
        Frame;
    End;
End;

//--------------------------
// Controls a single button
//--------------------------
Process button(Int font, String text, Int x, Int y);
Private
Int wide;   //The width of the hole text
Int max_n = 0;
Int n = 0;

Begin
    wide = get_size(font, text);
    If((max_n = len(text)) == 0)    //If i could just compare it to FALSE...
        Return -1;
    End;
    While(n < max_n)
        print(font, text[n++], x-(wide/2)+separation, y);  //Display the letters one by one
    End;
    Loop
       
        Frame;
    End;
End;

//---------------------------------------------------------
// Draws letters on the screen
// Implements a very basic physics system (simple gravity)
//---------------------------------------------------------
Process Print(Int font, String text, Int x, Int old_y);
Private
Int v_y=0;
Int old_v_y=0;
Int g=1;    //Newton Gravity (C)

Begin
    graph = write_in_map(font, text, 0);
    father.separation += graphic_info(0, graph, G_WIDE);
    y = old_y;
    old_v_y = rand(1, 4); //Initial value
    Loop
        If(active)
            If((rand(1, 50) == 3) && (done))    //A value for randomizing
                perform_rotation();
            End;
            y-=v_y;
            v_y-=g;
            If(y > old_y)
                y = old_y;
                v_y = old_v_y;
            End;
        Else
            If(y < old_y)   //Make it fall even if it's not active
                y-=v_y;
                v_y-=g;
            End;
        End;
        active = father.active;
        Frame;
    End;
End;

//------------------------------------------
// This makes the letters move to the sides
//------------------------------------------
Process perform_rotation();
Private
Int inc=1000;

Begin
    father.done = 0;
    angle = rand(5, 20)*1000;
    While(father.angle < angle)
        father.angle+=inc;
        Frame;
    End;
    While(father.angle > -angle)
        father.angle-=inc;
        Frame;
    End;
    While(father.angle < 0)
        father.angle+=inc;
        Frame;
    End;
    father.done = 1;
End;

//-----------------------------
//This must be passed a number
//-----------------------------
Process perform_action(Int action)
Begin
    say("Action: "+action+" Menu kind: "+action/10+" and subkind: "+action%10);
End;

//--------------------------------------------------
// Gets width of a text written with the given font
//--------------------------------------------------
Process Int get_size(Int font, String text); 
Begin
    Return graphic_info(0, write_in_map(font, text, 4), G_WIDE); //Last value of write_in_map shouldn't care here, should it?
End;
